ghc-7.10.2: The GHC API

Safe Haskell | None
Language | Haskell2010

FunDeps

# Documentation

data FDEq Source

Constructors

FDEq |
Fields fd_pos :: Int fd_ty_left :: Type fd_ty_right :: Type

Instances

Outputable FDEq |

data Equation loc Source

Constructors

FDEqn |
Fields fd_qtvs :: [TyVar] fd_eqs :: [FDEq] fd_pred1, fd_pred2 :: PredType fd_loc :: loc

pprEquation :: Equation a -> SDoc Source

improveFromInstEnv :: InstEnvs -> PredType -> [Equation SrcSpan] Source

improveFromAnother :: PredType -> PredType -> [Equation ()] Source

checkInstCoverage :: Bool -> Class -> [PredType] -> [Type] -> Validity Source

checkFunDeps :: InstEnvs -> ClsInst -> Maybe [ClsInst] Source

pprFundeps :: Outputable a => [FunDep a] -> SDoc Source